#!/usr/bin/awk -f
/^dst/ { dst=$2 }
/^level/ { for(i = 2; i <= NF; i++) { levels[i - 1] = $i } }
/^nodump/ { nodumps[$2]++ }
/^dump/ { dumps[$2] = $3 }
/^sync/ { syncs[$2]++ }
END {
	# nodumps
	print "Setze nodump flag:"
	for(path in nodumps) {
		print path
		if(system("chflags -R nodump " path)) 
			errors[++error] = "nodump " path " > Setzen des nodump flags nicht mglich."
		else 
			results[++result] = "nodump " path
	}
	# dumps
	print "Sichere Partitionen:"
	for(path in dumps) {
		print path
		r = dump(path, dst "/" dumps[path], levels)
		if(r)
			errors[++error] = "dump " path " " dumps[path] " > " r
		else 
			results[++result] = "dump " path " " dumps[path]
	}
	# syncs
	print "Synchronisiere Verzeichnisse:"
	for(path in syncs) {
		print path
		if(system("rsync -av " path " " dst)) 
			errors[++error] = "sync " path " > Synchronisation abgebrochen."
		else 
			results[++result] = "sync " path
	}
	# Statusbericht ausgeben
	print "\n\n>> Backup " getDate("%Y-%m-%d %H:%M:%S") " <<"
	print "Zielverzeichnis: " dst 
	if(result > 0) {
		print "\nFolgende Aktionen wurden erfolgreich ausgefhrt:"
		for(i = 1; i <= length(results); i++) print "  " results[i]
	} else {
	  print "\nEs wurden keine Aktionen erfolgreich ausgefhrt."
	}
	if(error > 0) {
		print "\nFolgende Aktionen sind fehlgeschlagen:"
		for(i = 1; i <= length(errors); i++)  print "  " errors[i]
	}
}

# Sichert eine Partition, abhngig von den bergebenen Leveln.
function dump(path, dst, levels) {
	# Name der letzten dump Datei holen
	lscmd = "ls -r " dst "*"
	lscmd | getline ls
	close lscmd
	# Levelnummer der letzten Datei holen und neue Nummer setzen
	l = split(ls, a, "_");
	n = a[l] + 1
	if(n > length(levels)) n = 1
	# dump ausfhren
	if(system("dump -" levels[n] " -Lauf " dst "_" getDate("%Y%m%d%H%M%S") "_" levels[n] "_" n " " path))
		return "Sicherung fehlgeschlagen!"
	# wenn erstes Dump, dann alle anderen lschen
	if(n == 1)
		for(i = 2; i <= length(levels); i++)
			if(system("rm -f " dst "*_" levels[i] "_" i))
				r = r "Sicherung \"" ls "\" konnte nicht gelscht werden.\n"
	return r
}

# Gibt die akteulle Zeit im gewnschten Format zurck.
function getDate(format) {
	datecmd = "date +'" format "'"
	datecmd | getline date
	close datecmd
	return date
}
